HDU - 2859 Phalanx (DP)

题目:
Today is army day, but the servicemen are busy with the phalanx for the celebration of the 60th anniversary of the PRC.
A phalanx is a matrix of size n*n, each element is a character (a~z or A~Z), standing for the military branch of the servicemen on that position.
For some special requirement it has to find out the size of the max symmetrical sub-array. And with no doubt, the Central Military Committee gave this task to ALPCs.
A symmetrical matrix is such a matrix that it is symmetrical by the “left-down to right-up” line. The element on the corresponding place should be the same. For example, here is a 3*3 symmetrical matrix:
cbx
cpb
zcc
Input
There are several test cases in the input file. Each case starts with an integer n (0 < n <= 1000), followed by n lines which has n character. There won’t be any blank spaces between characters or the end of line. The input file is ended with a 0.
Output
Each test case output one line, the size of the maximum symmetrical sub- matrix.
Sample Input
3
abx
cyb
zca
4
zaba
cbab
abbc
cacq
0
Sample Output
3
3

思路:
写的有点怀疑人生,对这种简单的dp都没思路,看题解还看了半天,不敢相信。
状态: dp[i][j] 表示到(i,j)的方阵的最长对角线,必选(i,j)这个点
所以转移方程就是:

这里写图片描述

这里上个图,例如对于(2,1)的e这个点,它的dp[2][1]明显是框出来的这一部分dp[1][2] = 2,而对于那个加粗的(3,0)的e,它最大肯定是dp[i-1][j+1]+1,即是dp[2][1]+1,要满足的条件就是加粗e上面的列和e右侧的行字母都是对应的。
若是不满足条件,则看在dp[i-1][j+1]的长度里,最大的上面的行和右侧的列能对应多少个相同的值。因为在这个长度范围内,可以保证除了e上方那列和右侧的行,里面的方阵都是对称矩阵。

代码:

#include <cstdio>
#include <iostream>
#include <cstring>
#include <algorithm>
using namespace std;
const int maxn = 1005;
char data[maxn][maxn];
int dp[maxn][maxn];


int main()
{
    int n;
    while(~scanf("%d",&n) && n)
    {
        for(int i = 0; i < n ; i++)
            scanf("%s",data[i]);
        int ans = 1;
        for(int i = 0; i < n ; i++)
        {
            dp[0][i] = 1;
            dp[i][n-1] = 1;
        }
        for(int i = 1; i < n ; i++)
        {
            for(int j = 0; j < n-1 ; j++)
            {
                int temp = dp[i-1][j+1];
                int v = 1;
                for(int k = 1;k <= temp; k++)
                {
                    if(data[i-k][j] == data[i][j+k])
                        v++;
                    else break;
                }
                dp[i][j] = v;
                ans = max(ans,dp[i][j]);
            }
        }
        printf("%d\n",ans);
    }
    return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值